from bs4 import BeautifulSoup
import requests
def ListToString(list_):
    string = ""
    for i in list_:
        string += i
    return string
def ListToString_better(list_):
    string = ""
    for i in list_:
        string += " "
        string += i
    return string
class video:
    def page(video_id, instance = ""):
        if instance == "":
            print("You have to use a instance like 'invidious.sethforprivacy.com'.")
        else:
            page = requests.get(f"https://{instance}/watch?v={video_id}")
            return {"page": page, "video_id": video_id}
    def genre(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        genre = soup.find('p',attrs={'id': 'genre'})
        genre = str(genre).split()
        del(genre[0])
        del(genre[0])
        del(genre[len(genre)-1])
        if len(genre) != 1:
            genre = ListToString_better(genre)
            genre = genre.replace("&amp;", "&")
            genre = genre[1:]
        print(genre)
    def views(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        views = soup.find('p',attrs={'id':'views'})
        views = str(views)
        views = views.split()
        views = views[4].replace("</p>","").replace(",","")
        return int(views)
    def likes(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        likes = soup.find('p',attrs={'id':'likes'})
        likes = str(likes)
        likes = likes.split()
        try:
            likes = likes[4].replace("</p>","")
        except:
            print("This Video is not a video, its a movie.\nIf you thing, its a mistake,\nwrite me at my email in the pypi project.")
        likes = likes.replace(",","")
        return int(likes)
    def title(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        title = soup.find('h1')
        title = str(title)
        title = title.replace(f'\n        \n            <a href="/watch?v={page["video_id"]}&amp;listen=1" title="Audio mode">\n<i class="icon ion-md-headset"></i>\n</a>\n</h1>',"")
        title = title.replace('<h1>\n        ',"")
        title = title.replace('&amp;', '')
        return str(title)
    def channel(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        span = soup.find('span',attrs={'id':'channel-name'})
        channel = str(span)
        channel = channel.replace('<span id="channel-name">',"")
        channel = channel.replace('</span>',"")
        channel = channel.replace('&amp;', '')
        channel = channel.replace('\xa0<i class="icon ion ion-md-checkmark-circle"></i>', '')
        return str(channel)
    def family_friendly(page):
        soup = BeautifulSoup(page["page"].content, 'html.parser')
        family = str(soup.find('p', attrs={'id': 'family_friendly'}))
        family = family.replace('<p id="family_friendly">Family friendly? ', '')
        family = family.replace('</p>', '')
        if family == 'Yes':
            return True
        else:
            return False
    def get_all(vid_id, instance = ""):
        if instance == "":
            print("You have to use a instance like 'invidious.sethforprivacy.com'.")
            exit(1)
        page = video.page(vid_id, instance)
        return {"views": video.views(page), "likes": video.likes(page), "title": video.title(page), "channel": video.channel(page), "family_friendly": video.family_friendly(page)}
